// Datei : DX8Font.h

// --------------------------------------------------------------------------------------
//
// Font Klasse
// zum Anzeigen von Schriften
//
// (c) 2002 Jrg M. Winterstein
//
// --------------------------------------------------------------------------------------

#ifndef __DX8Font_h__
#define __DX8Font_h__

// --------------------------------------------------------------------------------------
// Include Dateien
// --------------------------------------------------------------------------------------

#if defined(PLATFORM_DIRECTX)
#include <d3d8.h>
#endif
#include "DX8Sprite.h"

// --------------------------------------------------------------------------------------
// Klassendeklaration
// --------------------------------------------------------------------------------------

// --------------------------------------------------------------------------------------
// Font Klasse
// --------------------------------------------------------------------------------------

class DirectGraphicsFont
{
	private:
		DirectGraphicsSprite	*mTexture;						// Textur mit Font-Grafikdaten
		int						mXTextureSize;					// x-Grsse der gesamten Textur
		int						mYTextureSize;					// y-Grsse der gesamten Textur
		int						mXChars;						// Anzahl Zeichen in X-Richtung

	public:
		char					mCharLength[256];				// Lnge der Zeichen in Pixel
		int						mXCharSize;						// X-Grsse eines Zeichens
		int						mYCharSize;						// Y-Grsse eines Zeichens

			  DirectGraphicsFont(void);							// Konstruktor (leer)
			 ~DirectGraphicsFont(void);							// Textur freigeben
		bool LoadFont(const char *Filename,						// Laden des Bildes "Filename"
					  int xts,									// Textur-Grsse x
					  int yts,									// Textur-Grsse y
					  int xCharsize,							// x-Grsse eines Zeichens
					  int yCharsize,							// y-Grsse eines Zeichens
					  int xChars,								// Anzahl der Zeichen pro Zeile
					  int yChars);								// Anzahl der Zeichen pro Spalte
		bool DrawText(float x, float y,							// Text an xPos,yPos mit Farbe
					  const char Text[], D3DCOLOR Color);				// Color ausgeben
		bool DrawValue(float x, float y,						// Zahlenwert an xPos,yPos mit Farbe
					  float Value, D3DCOLOR Color);				// Color ausgeben
		void DrawTextRightAlign(float x, float y,				// Text an xPos,yPos mit Farbe
								const char Text[], D3DCOLOR Color,
								int Spacing = 1);				// Color ausgeben right aligned ausgeben
		void DrawTextCenterAlign(float x, float y,				// Text an xPos,yPos mit Farbe
								const char Text[], D3DCOLOR Color,
								int Spacing = 1);				// Color ausgeben right aligned ausgeben
		bool DrawDemoChar(float x, float y,							// Text an xPos,yPos mit Farbe
					  const char Text, D3DCOLOR Color);				// Color ausgeben
		bool DrawDemoText(float x, float y,							// Text an xPos,yPos mit Farbe
					  const char Text[], D3DCOLOR Color);				// Color ausgeben
		bool DrawText(float x, float y,							// Text an xPos,yPos mit Farbe
					  const char Text[], D3DCOLOR Color, int Spacing);// Color ausgeben
		int  DemoStringLength(const char Text[]);						// Lnge eines Strings in Pixeln zurckliefern
		int  StringLength(const char Text[]);							// Lnge eines Strings in Pixeln zurckliefern
		int  StringLength(const char Text[], int Spacing);			// Lnge eines Strings in Pixeln zurckliefern
		void ShowFPS (void);									// FPS Werte anzeigen
};

// --------------------------------------------------------------------------------------
// Externals
// --------------------------------------------------------------------------------------

extern DirectGraphicsFont *pMenuFont;
extern DirectGraphicsFont *pDefaultFont;
extern DirectGraphicsFont *pFont;

#endif

