// Datei : Logdatei.cpp

// --------------------------------------------------------------------------------------
//
// Logdatei Klasse
// zum leichten Handhaben einer Protokoll Datei
//
// (c) 2002 Jrg M. Winterstein
//
// --------------------------------------------------------------------------------------

// --------------------------------------------------------------------------------------
// Includes
// --------------------------------------------------------------------------------------

#include "Logdatei.h"									// Header-Datei einbinden
#if defined(PLATFORM_DIRECTX)
#include <windows.h>									// Windowsheader fr Messagebox und Beep#
#elif defined(PLATFORM_SDL)
#include "SDL_port.h"
#endif
#include <string.h>										// Fr String Operationen
#include <stdio.h>										// Fr Datei Operationen

// --------------------------------------------------------------------------------------
// Variablen
// --------------------------------------------------------------------------------------

FILE *Logfile;											// Logdatei

extern HWND					g_hwnd;						// Fenster Handle des Hauptfensters
extern bool					GameRunning;				// Luft das Spiel noch ?

// --------------------------------------------------------------------------------------
// Funktionen
// --------------------------------------------------------------------------------------

// --------------------------------------------------------------------------------------
// Konstruktor
// erstellt eine neue Logdatei mit dem Namen "Name"
// --------------------------------------------------------------------------------------

Logdatei::Logdatei(const char Name[20])
{
	int len = strlen(Name) + 1;
	strcpy_s(itsFilename, len, Name);							// Namen sichern
	fopen_s(&Logfile, itsFilename, "w");					// Datei neu erstellen
	fclose(Logfile);									// und gleich wieder schliessen

	delLogFile = false;
}

// --------------------------------------------------------------------------------------
// Destruktor
// --------------------------------------------------------------------------------------

Logdatei::~Logdatei()
{
}

// --------------------------------------------------------------------------------------
// WriteText
// schreibt den Text "Text" in die Logdatei
// bei Fehler-Eintrag ggf Messagebox ausgeben
// --------------------------------------------------------------------------------------

void Logdatei::WriteText(const char Text[180], bool Abbruch)
{
	fopen_s(&Logfile, itsFilename, "a");					// Datei zum anfgen ffnen
	fprintf_s(Logfile, Text);								// und Text schreiben
	fclose(Logfile);									// Datei wieder schliessen

	if(Abbruch == true)									// Abbruch nach Log-Eintrag ?
	{
		fopen_s(&Logfile, itsFilename, "a");					// Datei zum anfgen ffnen
		fprintf(Logfile, "\n    ^\n");
		fprintf(Logfile, "   /|\\\n");
		fprintf(Logfile, "    |\n");
		fprintf(Logfile, "    |\n");
		fprintf(Logfile, "    |\n");
		fprintf(Logfile, "  Error\n\n");
		fclose(Logfile);									// Datei wieder schliessen

#if defined(PLATFORM_DIRECTX)
		MessageBox (g_hwnd, Text, "Ein Fehler ist aufgetreten !", MB_OK | MB_ICONEXCLAMATION);
#elif defined(PLATFORM_SDL)
        printf ( "Ein Fehler ist aufgetreten !\n" );
#endif
		delLogFile  = false;
		GameRunning = false;
	}
}

// --------------------------------------------------------------------------------------
// WriteText
// schreibt den Wert "Value" in die Logdatei
// --------------------------------------------------------------------------------------

void Logdatei::WriteValue(int Value)
{
	fopen_s(&Logfile, itsFilename, "a");					// Datei zum anfgen ffnen
	fprintf(Logfile, "%i\n", Value);					// und Wert schreiben
	fclose(Logfile);									// Datei wieder schliessen
}
